Attribute VB_Name = "Helper"
Option Explicit

Public iUsedPixelFormats As Long
Public g_PixelFormats(256) As DDPIXELFORMAT
Dim lb As Object
Dim lBremse As Long
Dim lBremseTick As Long

Public Const RDH_RECTANGLES = 1
Type RGNDATAHEADER
  dwSize As Long
  iType As Long
  nCount As Long
  nRgnSize As Long
  rcBound As lRECT
End Type
Type RGNDATA
  rdh As RGNDATAHEADER
  r(10) As lRECT  'Die Anzahol der verfgbaren Rechtecke lt sich in einer eigenen Struktur anpassen
End Type

Declare Function GetTickCount Lib "Kernel32.dll" () As Long                 'Anzahl der Ticks seit Systemstart
Declare Sub GetWindowRect Lib "user32.dll" (ByVal hWnd As Long, r As lRECT) 'Gre/Position des Fenster

Declare Sub TextOutA Lib "gdi32.dll" (ByVal hdc As Long, ByVal nXStart As Long, ByVal nYStart As Long, ByVal lpString As String, ByVal cbString As Long) 'Text in HDC ausgeben

Public Const WM_QUIT = &H12
Public Const PM_NOREMOVE = 0
Public Const PM_REMOVE = 1
Public Const PM_NOYIELD = 2

Type Msg  'Message-Struktur fr getMessage/PeekMessage
  hWnd As Long    'Fr welches Fenster?
  message As Long 'Nachrichtencode
  wParam As Long  'Nachrichtenparameter
  lParam As Long  'Nachrichtenparameter
  time As Long    'Zeitpunkt der Nachricht
  pt As lPOINT    'absolute Mausposition
End Type

Declare Function PeekMessageA Lib "user32.dll" (lpMsg As Msg, ByVal hWnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long, ByVal remove As Long) As Long
Declare Function GetMessageA Lib "user32.dll" (lpMsg As Msg, ByVal hWnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Declare Function TranslateMessage Lib "user32.dll" (lpMsg As Msg) As Long
Declare Function DispatchMessageA Lib "user32.dll" (lpMsg As Msg) As Long
Declare Function PostQuitMessage Lib "user32.dll" (ByVal lQuit As Long) As Long

'zufllige Position innerhalb des gegebenen Rechtecks ermitteln
Public Sub RandomPosition(p As lPOINT, r As lRECT)
  Dim w As Long, h As Long
  Randomize GetTickCount()
  w = (r.right - r.left)
  h = (r.bottom - r.top)
  p.x = r.left + Int((w + 1) * Rnd)
  p.y = r.top + Int((h + 1) * Rnd)
End Sub

'Anzahl der verfgbaren Videomodes in Listbox eintrageb
Function EnumModesCallback(sd As DDSURFACEDESC, ByVal lpContext As Long) As Long
  If iUsedPixelFormats <> UBound(g_PixelFormats) Then
    g_PixelFormats(iUsedPixelFormats) = sd.ddpfPixelFormat
    iUsedPixelFormats = iUsedPixelFormats + 1
  End If
  
  lb.AddItem sd.dwWidth & " x " & sd.dwHeight & " x " & sd.Union2 & " x " & sd.ddpfPixelFormat.Union1
  EnumModesCallback = 1
End Function
  
'Alle Videomodes in Litbox eintragen
Public Sub EnumDisplayModes(l As ListBox)
  Dim lpDD As Long
  Set lb = l
  If ddDirectDrawCreate(0, ptr(lpDD), 0) = DD_OK Then
    l.Clear
    l.AddItem "< Im Fenster >"
    iUsedPixelFormats = LBound(g_PixelFormats)
    DirectDraw_EnumDisplayModes lpDD, DDEDM_REFRESHRATES Or DDEDM_STANDARDVGAMODES, 0&, 0, AddressOf EnumModesCallback
    Unknown_Release lpDD
  End If
  Set lb = Nothing
End Sub

Public Sub FillSurface(lpSurface As Long, dwColor As Long)
  Dim DDBLTFX As DDBLTFX
  DDBLTFX.dwSize = Len(DDBLTFX)
  DDBLTFX.Union5 = DDColorMatch(lpSurface, dwColor) 'dwFillColor
  DDPrintError DirectDrawSurface_Blt(lpSurface, 0, 0, 0, DDBLT_COLORFILL, ptr(DDBLTFX))
End Sub

Public Sub FillSurfaceRect(lpSurface As Long, dwColor As Long, r As lRECT)
  Dim DDBLTFX As DDBLTFX
  DDBLTFX.dwSize = Len(DDBLTFX)
  DDBLTFX.Union5 = DDColorMatch(lpSurface, dwColor) 'dwFillColor
  DDPrintError DirectDrawSurface_Blt(lpSurface, ptr(r), 0, 0, DDBLT_COLORFILL, ptr(DDBLTFX))
End Sub


Sub Main()
  Dim Msg As Msg
  
  InitGuids   'Alle GUID-Strukturen initialisieren

  MainFrm.Show
  
  lBremse = 0
  Do
    If PeekMessageA(Msg, 0, 0, 0, PM_REMOVE) Then
      If Msg.message = WM_QUIT Then Exit Do
      TranslateMessage Msg
      DispatchMessageA Msg
    Else
      If GetTickCount() - lBremseTick > lBremse Then
        MainFrm.GameStep 1
        lBremseTick = GetTickCount()
      End If
    End If
  Loop Until False
End Sub


Public Function DoubleMod(ByVal a As Double, ByVal m As Double) As Double
  While a >= m: a = a - m: Wend
  DoubleMod = a
End Function

