VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sprite"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim dPos As dPOINT    'Position des Sprites
Dim pSize As lPOINT   'Hhe und Breite des Sprites

Dim rSource As lRECT            'Position der aktuellen
                                'Phase innerhalb der
                                'OffscreenBitmap
Dim lpOffscreenSurface As Long  'Zeiger auf OffscreenBitmap

Dim lDirection As Long  'Bewegungsrichtung in Zehntelgrad
                        'Wertebereich: (0 - 3599)
Dim lDistance As Double 'Lnge der Bewegung in Pixeln
                        '(-1 = unendlich)
Dim lSpeed As Double    'Geschwindigkeit (Pixel pro Frame)
Dim lVelocity As Double 'Geschwindigkeitszu/abnahme'
                        '(pro Frame)

Dim bVisible As Boolean   'Sprite sichtbar?
Dim bFastMode As Boolean  'Blitten mit BltFast()
                          'oder mit Blt()?
Dim bTransMode As Boolean  'Blitten mit BltFast()

Dim DDBLTFX As DDBLTFX    'DDBLTFX fr Blitten mit Blt()

Private Sub Class_Initialize()
  dPos.x = 0#
  dPos.y = 0#
  pSize.x = 0
  pSize.y = 0
  bVisible = False
  bFastMode = False
  
  lDirection = 0
  lDistance = 0
  lSpeed = 0
  bTransMode = True
End Sub

'Initialisierung des Sprites mit Offscreen-Surface
Public Sub SetOffscreenSurface(s As Long)
  lpOffscreenSurface = s
End Sub

'Auswahl des Rechtecks fr nchste Phase
Public Sub Animate(l As Long, _
                   t As Long, _
                   r As Long, _
                   b As Long)
  rSource.left = l
  rSource.top = t
  rSource.right = r
  rSource.bottom = b
End Sub

'Zeichnen der aktuellen Phase in die angegebene Ziel-Surface
Public Sub Draw(lpDestSurface As Long, _
                px As Long, _
                py As Long)
  Dim h As Long
  Dim rDest As lRECT
  
  'Die Parameter px und py sind Korrekturpositionen fr
  'den Betrieb bei scrollenden Hintergrnden
  If bVisible Then
    bFastMode = True
    If bFastMode Then
      'Bltfast bentigt kein Zielrechteck
      If bTransMode Then
        h = DirectDrawSurface_BltFast(lpDestSurface, _
                                      CLng(dPos.x) - px, _
                                      CLng(dPos.y) - py, _
                                      lpOffscreenSurface, _
                                      ptr(rSource), _
                                      DDBLTFAST_WAIT Or _
                                      DDBLTFAST_SRCCOLORKEY)
      Else
        h = DirectDrawSurface_BltFast(lpDestSurface, _
                                      CLng(dPos.x) - px, _
                                      CLng(dPos.y) - py, _
                                      lpOffscreenSurface, _
                                      ptr(rSource), _
                                      DDBLT_WAIT)
      End If
      
    Else
      'Berechnung des Zielrechtecks
      '(Blitten ohne Vergrerung)
      rDest.left = CLng(dPos.x) - px
      rDest.top = CLng(dPos.y) - py
      rDest.right = rDest.left + pSize.x
      rDest.bottom = rDest.top + pSize.y
      
      'Der ColorKey fr das Blitten via Blt mu nicht nur
      'via SetColorKey in der OffscreenSurface gesetzt
      'werden, sondern auch via TransparencyColor.
      'Ein Bug im Treiber verschiedener Grafikkarten
      'verhindert die Nutzung des SrcColorKeys durch
      'Angabe des Flags DDBLT_KEYSRC. Erst
      'DDBLT_KEYSRCOVERRIDE und eine entsprechend
      'vorbereitete DDBLTFX-Struktur fhren zum Erfolg
      DDBLTFX.dwSize = Len(DDBLTFX)
      If bTransMode Then
        h = DirectDrawSurface_Blt(lpDestSurface, _
                                  ptr(rDest), _
                                  lpOffscreenSurface, _
                                  ptr(rSource), _
                                  DDBLT_WAIT Or _
                                  DDBLT_KEYSRCOVERRIDE, _
                                  ptr(DDBLTFX))
      Else
        h = DirectDrawSurface_Blt(lpDestSurface, _
                                  ptr(rDest), _
                                  lpOffscreenSurface, _
                                  ptr(rSource), _
                                  DDBLT_WAIT, _
                                  0)
      End If
    End If
    DDPrintError h
  End If
End Sub

'Sprite um angegebenen Betrag verschieben
Public Sub DeltaMove(ByVal x As Double, ByVal y As Double)
    dPos.x = dPos.x + x
    dPos.y = dPos.y + y
End Sub

'Sprite auf absolute Position setzen
Public Sub Move(ByVal x As Double, ByVal y As Double)
  dPos.x = x
  dPos.y = y
End Sub

'Gre des Srptes bzw. einer Phase setzen
Public Sub SetSize(ByVal x As Long, ByVal y As Long)
  pSize.x = x
  pSize.y = y
End Sub

'Koordintaen innerhalb des angegeben Rechtecks?
'An den Kanten "prallt" das Sprite ab.
'Regel: Einfallwinkel = Auswfallwinkel
Public Sub Bounce(l As Long, t As Long, r As Long, b As Long)
  While lDirection < 0
    lDirection = lDirection + 3600
  Wend
  lDirection = lDirection Mod 3600
  If dPos.x < l Then
    dPos.x = l
    If (lDirection >= 1800) And (lDirection <= 2700) Then
      lDirection = 1800 - (lDirection - 1800)
    ElseIf lDirection >= 2700 Then
      lDirection = 900 - (lDirection - 2700)
    End If
  End If
  
  If dPos.y < t Then
    dPos.y = t
    If lDirection >= 2700 Then
      lDirection = 2700 - (lDirection - 2700)
    ElseIf lDirection <= 900 Then
      lDirection = 900 + (900 - lDirection)
    End If
  End If
  
  If dPos.x + pSize.x > r Then
    dPos.x = r - pSize.x
    If lDirection <= 900 Then
      lDirection = 2700 + (900 - lDirection)
    ElseIf (lDirection >= 900) And (lDirection <= 1800) Then
      lDirection = 2700 - (lDirection - 900)
    End If
  End If
  
  If dPos.y + pSize.y > b Then
    dPos.y = b - pSize.y
    If (lDirection > 900) And (lDirection <= 1800) Then
      lDirection = 900 - (lDirection - 900)
    ElseIf (lDirection >= 1800) And (lDirection < 2700) Then
      lDirection = 2700 + (2700 - lDirection)
    End If
  End If
End Sub

'Eigenschaft: Visible (Sichtbar)
Public Property Get Visible() As Boolean
  Visible = bVisible
End Property
Public Property Let Visible(ByVal bNewValue As Boolean)
  bVisible = bNewValue
End Property

'Eigenschaft: x (aktuelle, absolute Position)
Public Property Get x() As Double
  x = dPos.x
End Property
Public Property Let x(ByVal lNewValue As Double)
  dPos.x = lNewValue
End Property

'Eigenschaft: y (aktuelle, absolute Position)
Public Property Get y() As Double
  y = dPos.y
End Property
Public Property Let y(ByVal lNewValue As Double)
  dPos.y = lNewValue
End Property

'Eigenschaft: w (aktuelle Breite einer Phase)
Public Property Get w() As Long
  w = pSize.x
End Property
Public Property Let w(ByVal lNewValue As Long)
  pSize.x = lNewValue
End Property

'Eigenschaft: h (aktuelle Hhe einer Phase)
Public Property Get h() As Long
  h = pSize.y
End Property
Public Property Let h(ByVal lNewValue As Long)
  pSize.y = lNewValue
End Property

'Eigenschaft: FastMode (BltFast oder Blt?)
Public Property Get FastMode() As Boolean
    FastMode = bFastMode
End Property
Public Property Let FastMode(ByVal vNewValue As Boolean)
    bFastMode = vNewValue
End Property

'Eigenschaft: TransMode (BltFast oder Blt?)
Public Property Get TransMode() As Boolean
    TransMode = bTransMode
End Property
Public Property Let TransMode(ByVal vNewValue As Boolean)
    bTransMode = vNewValue
End Property

'Eigenschaft: TransparencyColor (TransparenzFarbe fr Blt)
Public Property Let TransparencyColor( _
                                    ByVal lRGBColor As Long)
  If lpOffscreenSurface Then
    DDBLTFX.ddckSrcColorkey.dwColorSpaceLowValue = _
                 DDColorMatch(lpOffscreenSurface, lRGBColor)
    DDBLTFX.ddckSrcColorkey.dwColorSpaceHighValue = _
                DDBLTFX.ddckSrcColorkey.dwColorSpaceLowValue
  End If
End Property

'Eigenschaft: Speed (aktuelle Geschwindigkeit)
Public Property Get Speed() As Double
  Speed = lSpeed
End Property
Public Property Let Speed(ByVal lNewValue As Double)
  lSpeed = lNewValue
End Property

'Eigenschaft: Direction (aktuelle Bewegungsrichtung)
Public Property Get Direction() As Long
      Direction = lDirection
End Property
Public Property Let Direction(ByVal lNewValue As Long)
    lDirection = lNewValue
End Property

'Eigenschaft: Distance (aktuelle Bewegungsrichtung)
Public Property Get Distance() As Long
      Distance = lDistance
End Property
Public Property Let Distance(ByVal lNewValue As Long)
    lDistance = lNewValue
End Property

'Eigenschaft: Velocity (aktuelle Bewegungsrichtung)
Public Property Get Velocity() As Double
      Velocity = lVelocity
End Property
Public Property Let Velocity(ByVal lNewValue As Double)
    lVelocity = lNewValue
End Property

'Befindet sich die angegebene position innerhalb des
'vom Sprite eingenommenen Rechteck?
Public Function InRect(ByVal x As Long, ByVal y As Long) As Boolean
  InRect = (x >= dPos.x) And _
           (y >= dPos.y) And _
           (x < dPos.x + pSize.x) And _
           (y < dPos.y + pSize.y)
End Function

'Bewegt sich das Spriten noch
Public Property Get Moving() As Boolean
  Moving = (lDistance <> 0)
End Property

'Position des Sprites aufgrund aktueller Geschwindigkeits
'Einstellungen aktualisieren
Public Sub NextSpeed()
  Dim d As Double
  
  If lDistance Then
    If lVelocity Then
      lSpeed = lSpeed + lVelocity
      If lSpeed < 0 Then lSpeed = 0
    End If
    
    If lDistance > 0 Then
      lDistance = lDistance - lSpeed
      If lDistance < 0 Then
        lSpeed = lSpeed + lDistance: lDistance = 0
      End If
    End If
    
    'Wnkel der Bewegungsrichtung berechnen
    d = ((lDirection Mod 3600#) * 2# * 3.141529) / 3600#
    'Geschwindigkeitskomponenten in Bewegungsrichtung
    'berechnen
    x = x + Sin(d) * lSpeed
    y = y - Cos(d) * lSpeed
  End If
End Sub

