Attribute VB_Name = "Subclassing"
Option Explicit

Declare Function LoadCursorLong Lib "user32.dll" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long
Declare Function SetCursor Lib "user32.dll" (ByVal hCursor As Long) As Long
Declare Function CallWindowProcA Lib "user32.dll" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function DefWindowProcA Lib "user32.dll" (ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLongA Lib "user32.dll" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function GetClassLongA Lib "user32.dll" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Declare Function GetSystemMetrics Lib "user32.dll" (ByVal nIndex As Long) As Long
Declare Function InvalidateRect Lib "user32.dll" (ByVal hWnd As Long, ByVal RECT As Long, ByVal berase As Integer) As Integer
Declare Function BeginPaint Lib "user32.dll" (ByVal hWnd As Long, ByVal lpPaint As Any) As Long
Declare Function EndPaint Lib "user32.dll" (ByVal hWnd As Long, ByVal lpPaint As Any) As Boolean
Declare Function RedrawWindow Lib "user32.dll" (ByVal hWnd As Long, ByVal lprcUpdate As Long, ByVal hrgnUpdate As Long, ByVal flags As Long) As Integer

Public Const RDW_INVALIDATE = &H1
Public Const RDW_INTERNALPAINT = &H2
Public Const RDW_ERASE = &H4
Public Const RDW_VALIDATE = &H8
Public Const RDW_NOINTERNALPAINT = &H10
Public Const RDW_NOERASE = &H20
Public Const RDW_NOCHILDREN = &H40
Public Const RDW_ALLCHILDREN = &H80
Public Const RDW_UPDATENOW = &H100
Public Const RDW_ERASENOW = &H200
Public Const RDW_FRAME = &H400
Public Const RDW_NOFRAME = &H800
  
Type PAINTSTRUCT
    hdc As Long
    fErase As Integer
    rcPaint As lRECT
    fRestore As Integer
    fIncUpdate As Integer
    rgbReserved() As Byte
End Type
  
Public Const SM_CXSCREEN = 0
Public Const SM_CYSCREEN = 1
Public Const SM_CXVSCROLL = 2
Public Const SM_CYHSCROLL = 3
Public Const SM_CYCAPTION = 4
Public Const SM_CXBORDER = 5
Public Const SM_CYBORDER = 6
Public Const SM_CXDLGFRAME = 7
Public Const SM_CYDLGFRAME = 8
Public Const SM_CYVTHUMB = 9
Public Const SM_CXHTHUMB = 10
Public Const SM_CXICON = 11
Public Const SM_CYICON = 12
Public Const SM_CXCURSOR = 13
Public Const SM_CYCURSOR = 14
Public Const SM_CYMENU = 15
Public Const SM_CXFULLSCREEN = 16
Public Const SM_CYFULLSCREEN = 17
Public Const SM_CYKANJIWINDOW = 18
Public Const SM_MOUSEPRESENT = 19
Public Const SM_CYVSCROLL = 20
Public Const SM_CXHSCROLL = 21
Public Const SM_DEBUG = 22
Public Const SM_SWAPBUTTON = 23
Public Const SM_RESERVED1 = 24
Public Const SM_RESERVED2 = 25
Public Const SM_RESERVED3 = 26
Public Const SM_RESERVED4 = 27
Public Const SM_CXMIN = 28
Public Const SM_CYMIN = 29
Public Const SM_CXSIZE = 30
Public Const SM_CYSIZE = 31
Public Const SM_CXFRAME = 32
Public Const SM_CYFRAME = 33
Public Const SM_CXMINTRACK = 34
Public Const SM_CYMINTRACK = 35
Public Const SM_CXDOUBLECLK = 36
Public Const SM_CYDOUBLECLK = 37
Public Const SM_CXICONSPACING = 38
Public Const SM_CYICONSPACING = 39
Public Const SM_MENUDROPALIGNMENT = 40
Public Const SM_PENWINDOWS = 41
Public Const SM_DBCSENABLED = 42
Public Const SM_CMOUSEBUTTONS = 43

Public Const SM_CXFIXEDFRAME = SM_CXDLGFRAME
Public Const SM_CYFIXEDFRAME = SM_CYDLGFRAME
Public Const SM_CXSIZEFRAME = SM_CXFRAME
Public Const SM_CYSIZEFRAME = SM_CYFRAME

Public Const SM_SECURE = 44
Public Const SM_CXEDGE = 45
Public Const SM_CYEDGE = 46
Public Const SM_CXMINSPACING = 47
Public Const SM_CYMINSPACING = 48
Public Const SM_CXSMICON = 49
Public Const SM_CYSMICON = 50
Public Const SM_CYSMCAPTION = 51
Public Const SM_CXSMSIZE = 52
Public Const SM_CYSMSIZE = 53
Public Const SM_CXMENUSIZE = 54
Public Const SM_CYMENUSIZE = 55
Public Const SM_ARRANGE = 56
Public Const SM_CXMINIMIZED = 57
Public Const SM_CYMINIMIZED = 58
Public Const SM_CXMAXTRACK = 59
Public Const SM_CYMAXTRACK = 60
Public Const SM_CXMAXIMIZED = 61
Public Const SM_CYMAXIMIZED = 62
Public Const SM_NETWORK = 63
Public Const SM_CLEANBOOT = 67
Public Const SM_CXDRAG = 68
Public Const SM_CYDRAG = 69
Public Const SM_SHOWSOUNDS = 70
Public Const SM_CXMENUCHECK = 71
Public Const SM_CYMENUCHECK = 72
Public Const SM_SLOWMACHINE = 73
Public Const SM_MIDEASTENABLED = 74
Public Const SM_MOUSEWHEELPRESENT = 75
Public Const SM_XVIRTUALSCREEN = 76
Public Const SM_YVIRTUALSCREEN = 77
Public Const SM_CXVIRTUALSCREEN = 78
Public Const SM_CYVIRTUALSCREEN = 79
Public Const SM_CMONITORS = 80
Public Const SM_SAMEDISPLAYFORMAT = 81
  
  
Public Const WM_SETCURSOR = &H20
Public Const WM_PAINT = &HF
Public Const WM_NCPAINT = &H85
Public Const GWL_WNDPROC = -4
Public Const GWL_HINSTANCE = -6
Public Const GWL_HWNDPARENT = -8
Public Const GWL_STYLE = -16
Public Const GWL_EXSTYLE = -20
Public Const GWL_USERDATA = -21
Public Const GWL_ID = -12
  
Public Const GCL_MENUNAME = -8
Public Const GCL_HBRBACKGROUND = -10
Public Const GCL_HCURSOR = -12
Public Const GCL_HICON = -14
Public Const GCL_HMODULE = -16
Public Const GCL_CBWNDEXTRA = -18
Public Const GCL_CBCLSEXTRA = -20
Public Const GCL_WNDPROC = -24
Public Const GCL_STYLE = -26
Public Const GCW_ATOM = -32
  
Public Const IDC_ARROW = 32512
Public Const IDC_IBEAM = 32513
Public Const IDC_WAIT = 32514
Public Const IDC_CROSS = 32515
Public Const IDC_UPARROW = 32516
Public Const IDC_SIZE = 32640
Public Const IDC_ICON = 32641
Public Const IDC_SIZENWSE = 32642
Public Const IDC_SIZENESW = 32643
Public Const IDC_SIZEWE = 32644
Public Const IDC_SIZENS = 32645
Public Const IDC_SIZEALL = 32646
Public Const IDC_NO = 32648
Public Const IDC_HAND = 32649
Public Const IDC_APPSTARTING = 32650
Public Const IDC_HELP = 32651

Public Const WM_KEYDOWN = &H100
Public Const WM_KEYUP = &H101
Public Const WM_CHAR = &H102
Public Const WM_DEADCHAR = &H103
Public Const WM_SYSKEYDOWN = &H104
Public Const WM_SYSKEYUP = &H105
Public Const WM_SYSCHAR = &H106
Public Const WM_SYSDEADCHAR = &H107

Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_MBUTTONDOWN = &H207
Public Const WM_MBUTTONUP = &H208
Public Const WM_NCHITTEST = &H84


Public Const HTTRANSPARENT = (-1)
Public Const HTNOWHERE = 0
Public Const HTCLIENT = 1
Public Const HTCAPTION = 2
Public Const HTSYSMENU = 3
Public Const HTGROWBOX = 4
Public Const HTSIZE = HTGROWBOX
Public Const HTMENU = 5
Public Const HTHSCROLL = 6
Public Const HTVSCROLL = 7
Public Const HTMINBUTTON = 8
Public Const HTMAXBUTTON = 9
Public Const HTLEFT = 10
Public Const HTRIGHT = 11
Public Const HTTOP = 12
Public Const HTTOPLEFT = 13
Public Const HTTOPRIGHT = 14
Public Const HTBOTTOM = 15
Public Const HTBOTTOMLEFT = 16
Public Const HTBOTTOMRIGHT = 17
Public Const HTBORDER = 18
Public Const HTREDUCE = HTMINBUTTON
Public Const HTZOOM = HTMAXBUTTON
Public Const HTSIZEFIRST = HTLEFT
Public Const HTSIZELAST = HTBOTTOMRIGHT
Public Const HTOBJECT = 19
Public Const HTCLOSE = 20

Public Function SubclassWindow(ByVal hWnd As Long, ByVal wmsg As Long, ByVal wp As Long, ByVal lp As Long) As Long
  Select Case wmsg
    Case WM_SETCURSOR
      SetCursor 0
      SubclassWindow = 1
      Exit Function
    Case WM_NCHITTEST
      'Whrend die Anwendung luft, kann das Fenster nicht mit der Maus bewegt werden
      
      SubclassWindow = HTNOWHERE
      Exit Function
      
    Case WM_PAINT
      Dim ps As PAINTSTRUCT
      BeginPaint hWnd, ptr(ps)
      EndPaint hWnd, ptr(ps)
      SubclassWindow = 0
      Exit Function
    
    Case WM_NCPAINT
      SubclassWindow = 0
      Exit Function
    
  End Select
  SubclassWindow = CallWindowProcA(GetClassLongA(hWnd, GCL_WNDPROC), hWnd, wmsg, wp, lp)
End Function

